package arboles23.modelo;

public class Arbol23 {
	private NodoArbol23 raiz;

	public Arbol23() {
		raiz = null;
	}

	public void inicializar() {
		NodoArbol23 nodo1 = new NodoArbol23();
		nodo1.setR1(new Entero(15));
		nodo1.setR2(new Entero(63));
		raiz = nodo1;

		NodoArbol23 nodo2 = new NodoArbol23();
		nodo2.setR1(new Entero(1));
		nodo2.setR2(new Entero(8));

		nodo1.setHijo1(nodo2);

		NodoArbol23 nodo3 = new NodoArbol23();
		nodo3.setR1(new Entero(30));

		nodo1.setHijo2(nodo3);

		NodoArbol23 nodo4 = new NodoArbol23();
		nodo4.setR1(new Entero(79));

		nodo1.setHijo3(nodo4);

		NodoArbol23 nodo5 = new NodoArbol23();
		nodo5.setR1(new Entero(0));

		nodo2.setHijo1(nodo5);

		NodoArbol23 nodo6 = new NodoArbol23();
		nodo6.setR1(new Entero(2));

		nodo2.setHijo2(nodo6);

		NodoArbol23 nodo7 = new NodoArbol23();
		nodo7.setR1(new Entero(9));
		nodo7.setR2(new Entero(14));

		nodo2.setHijo3(nodo7);

		NodoArbol23 nodo8 = new NodoArbol23();
		nodo8.setR1(new Entero(27));

		nodo3.setHijo1(nodo8);

		NodoArbol23 nodo9 = new NodoArbol23();
		nodo9.setR1(new Entero(60));

		nodo3.setHijo2(nodo9);

		NodoArbol23 nodo10 = new NodoArbol23();
		nodo10.setR1(new Entero(65));

		nodo4.setHijo1(nodo10);

		NodoArbol23 nodo11 = new NodoArbol23();
		nodo11.setR1(new Entero(81));

		nodo4.setHijo2(nodo11);
	}

	public NodoArbol23 buscar(Object elemento) {
		Comparable dato = (Comparable) elemento;
		// Bajar por el camino de busqueda
		// comenzando por la raiz
		NodoArbol23 aux = raiz;
		while (aux != null) {
			if (aux.getR1().esIgual(dato))
				return aux;
			else {
				if (aux.getR2() != null) {
					if (aux.getR2().esIgual(dato))
						return aux;
				}
				if (dato.esMenor(aux.getR1()))
					aux = aux.getHijo1();
				else {
					if (aux.getR2() != null) {
						if (dato.esMenor(aux.getR2()))
							aux = aux.getHijo2();
						else
							aux = aux.getHijo3();

					} else
						aux = aux.getHijo2();
				}
			}
		}
		return null;
	}
}
