package arboln.cliente;

import utilidades.PosicionIlegalException;
import arboln.modelo.ArbolN;
import arboln.modelo.Letra;
import arboln.modelo.NodoArbolN;

/**
 * Crea un arboln y prueba las operaciones de agregar, busquedas
 * 
 * @author libardo
 *
 */
public class ClienteMain {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ArbolN arbol = new ArbolN();
		NodoArbolN nodoA = new NodoArbolN(new Letra('A'));
		NodoArbolN nodoB = new NodoArbolN(new Letra('B'));
		NodoArbolN nodoC = new NodoArbolN(new Letra('C'));
		NodoArbolN nodoD = new NodoArbolN(new Letra('D'));
		NodoArbolN nodoE = new NodoArbolN(new Letra('E'));
		NodoArbolN nodoF = new NodoArbolN(new Letra('F'));
		NodoArbolN nodoG = new NodoArbolN(new Letra('G'));
		NodoArbolN nodoH = new NodoArbolN(new Letra('H'));
		NodoArbolN nodoI = new NodoArbolN(new Letra('I'));
		NodoArbolN nodoJ = new NodoArbolN(new Letra('J'));
		NodoArbolN nodoK = new NodoArbolN(new Letra('K'));
		NodoArbolN nodoL = new NodoArbolN(new Letra('L'));
		NodoArbolN nodoM = new NodoArbolN(new Letra('M'));
		
		arbol.setRaiz(nodoA);
		arbol.agregarNodo(nodoA, nodoB);
		arbol.agregarNodo(nodoA, nodoC);
		arbol.agregarNodo(nodoA, nodoD);
		arbol.agregarNodo(nodoC, nodoE);
		arbol.agregarNodo(nodoC, nodoF);
		arbol.agregarNodo(nodoD, nodoG);
		arbol.agregarNodo(nodoD, nodoH);
		arbol.agregarNodo(nodoD, nodoI);
		arbol.agregarNodo(nodoG, nodoJ);
		arbol.agregarNodo(nodoG, nodoK);
		arbol.agregarNodo(nodoG, nodoL);
		arbol.agregarNodo(nodoG, nodoM);
		
		try {
			System.out.println("Recorrido inorden:");
			arbol.inordenArbolN();
			System.out.println("\nRecorrido preorden:");
			arbol.preordenArbolN();
			System.out.println("\nRecorrido postorden:");
			arbol.postordenArbolN();			
			System.out.println("\nBuscando valor:");
			System.out.println(arbol.buscarNodoArbolN(new Letra('L')));
			arbol.getRaiz().print();
		} catch (PosicionIlegalException e) {
			System.out.println(e.getMessage());
		}
		
	}

}
