package arbol.avl.cliente;

import arbol.avl.modelo.ArbolAVL;
import arbol.binariodebusqueda.modelo.Entero;
import arbol.graficar.BTreePrinter;
import arbol.graficar.GUIArbolBinario;

public class ClienteMainAVL {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ArbolAVL abo = new ArbolAVL();
		//20, 10, 40, 50, 90, 30, 60 y 70.
		try{
			abo.insertar(new Entero(20));
			abo.insertar(new Entero(10));
			abo.insertar(new Entero(40));
			
			abo.insertar(new Entero(50));
			abo.insertar(new Entero(90));
			abo.insertar(new Entero(30));
			abo.insertar(new Entero(60));
			abo.insertar(new Entero(70));
			
			
		}
		catch(Exception e)
		{
			System.out.println("Error:" + e.getMessage());
			
		}

		//Graficar el arbol
		GUIArbolBinario inst = new GUIArbolBinario();
		inst.setVisible(true);		
		inst.getTablero().dibujar(abo.getRaiz());
		//Graficar por consola
		BTreePrinter.printNode(abo.getRaiz());
	}

}
