package arbol.binario.modelo;

/**
 * Representa un nodo que contiene tres campos: valor, izquierdo y derecho
 * 
 * @author Libardo
 * 
 */
public class Nodo {
	private Object valor;
	private Nodo izquierdo;
	private Nodo derecho;

	public Nodo() {
		valor = null;
		izquierdo = null;
		derecho = null;
	}

	public Nodo(Object valor) {
		this.valor = valor;
		izquierdo = null;
		derecho = null;
	}


	public Object getValor() {
		return valor;
	}

	public void setValor(Object valor) {
		this.valor = valor;
	}

	public Nodo getIzquierdo() {
		return izquierdo;
	}

	public Nodo getDerecho() {
		return derecho;
	}

	public void setIzquierdo(Nodo izquierdo) {
		this.izquierdo = izquierdo;
	}

	public void setDerecho(Nodo derecho) {
		this.derecho = derecho;
	}
}