package arbol.graficar;

import javax.swing.WindowConstants;
import javax.swing.border.LineBorder;
import javax.swing.SwingUtilities;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

import arbol.binariodebusqueda.modelo.ArbolBinarioOrdenado;
import arbol.binariodebusqueda.modelo.Entero;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Esta clase permite graficar cualquir arbol binario. Para ello se siguen los siguientes pasos:
 * 		GUIArbolBinario inst = new GUIArbolBinario();
		inst.setVisible(true);		
		inst.getTablero().dibujar(abo.getRaiz());
 * @author libardo
 *
 */
public class GUIArbolBinario extends javax.swing.JFrame {
    private Tablero tablero;
    private JButton btnCerrar;
    private JPanel pnlSur;

	public Tablero getTablero(){
		return tablero;
	}
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				GUIArbolBinario inst = new GUIArbolBinario();
				inst.setLocationRelativeTo(null);
				inst.setVisible(true);
				//Se crea un arbol binario por defecto
				ArbolBinarioOrdenado arbol = new ArbolBinarioOrdenado();
				try{
				arbol.insertar(new Entero(400));
				arbol.insertar(new Entero(3));
				arbol.insertar(new Entero(700));
				arbol.insertar(new Entero(650));
				arbol.insertar(new Entero(800));
				arbol.insertar(new Entero(750));
				arbol.insertar(new Entero(900));
				arbol.insertar(new Entero(850));
				arbol.insertar(new Entero(950));
				arbol.insertar(new Entero(760));
				arbol.insertar(new Entero(749));
				arbol.insertar(new Entero(762));
				arbol.insertar(new Entero(758));
				arbol.insertar(new Entero(849));
				arbol.insertar(new Entero(852));
				}
				catch(Exception e){
					System.out.println("Error:" + e.getMessage());
				}
				inst.tablero.dibujar(arbol.getRaiz());				
			
			}
		});
	}
	
	public GUIArbolBinario() {
		super();
		initGUI();
	}
	
	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			this.setTitle("Visualizador de Arboles Binarios");
			{
				tablero = new Tablero();
				getContentPane().add(tablero, BorderLayout.CENTER);
				tablero.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
			}
			{
				pnlSur = new JPanel();
				getContentPane().add(pnlSur, BorderLayout.SOUTH);
				pnlSur.setBorder(BorderFactory.createTitledBorder(""));
				{
					btnCerrar = new JButton();
					pnlSur.add(btnCerrar);
					btnCerrar.setText("Cerrar");
					btnCerrar.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							btnCerrarActionPerformed(evt);
						}
					});
				}
			}
			setIconImage (new ImageIcon("icono.gif").getImage());
			pack();
			setSize(1000, 500);
		} catch (Exception e) {
		    //add your error handling code here
			e.printStackTrace();
		}
	}
	
	private void btnCerrarActionPerformed(ActionEvent evt) {
		System.exit(0);
	}
	
}
