package arboles23.cliente;

import arboles23.modelo.Arbol23;
import arboles23.modelo.Entero;
import arboles23.modelo.NodoArbol23;

/**
 * Crea un arbol23 y luego hace una busqueda de un nodo
 * @author libardo
 *
 */
public class ClienteMain {

	public static void main(String[] args) {
		Arbol23 arbol = new Arbol23();
		arbol.inicializar();
		NodoArbol23 nodo = arbol.buscar(new Entero(32));
		if(nodo==null)
			System.out.println("No encontrado");
		else
			System.out.println("Encontrado r1:" + nodo.getR1().toString()  + " r2:" + (nodo.getR2()!=null?nodo.getR2().toString():"vacio"));

		nodo = arbol.buscar(new Entero(8));
		if(nodo==null)
			System.out.println("No encontrado");
		else
			System.out.println("Encontrado r1:" + nodo.getR1().toString()  + " r2:" + (nodo.getR2()!=null?nodo.getR2().toString():"vacio"));
		
	}

}
